<?php

namespace App\Installation;

use App\Installation\Contracts\Instructions;
use Illuminate\Support\Facades\Storage;

class ConfigInstructions extends Instructions
{
    public function name(): string
    {
        return 'DRPG Installer Config';
    }

    public function canRun(): bool
    {
        return Storage::disk('project')->exists($this->configFile());
    }

    protected function commands(): array
    {
        $config = json_decode(Storage::disk('project')->get($this->configFile()), false);

        return array_map(function ($command) {
            return $this->command($command);
        }, $config->commands ?? []);
    }

    private function configFile(): string
    {
        return 'drp-installer.json';
    }
}
