<?php

namespace App\Installation;

use App\Installation\Contracts\Instructions;
use Illuminate\Support\Arr;

class InstructionManual
{
    private $classes = [
        ConfigInstructions::class,
        LaravelInstructions::class,
        WordpressInstructions::class,
        DrupalInstructions::class,
        ComposerInstructions::class,
        NodeInstructions::class,
    ];

    public function __construct()
    {
        $this->boot();
    }

    private function boot(): void
    {
        $this->classes = array_map(static function (string $class) {
            return app($class);
        }, $this->classes);
    }

    public function read(): ?Instructions
    {
        return Arr::first($this->classes, static function (Instructions $instruction) {
            return $instruction->canRun();
        });
    }
}
